# -*- coding: utf-8 -*-
'''
GTKRawGallery Facebook publisher;
copyright © 2013 Daniele Isca
license: GNU GPL v.3 (see COPYING.txt);
This software comes with no warranty of any kind, use at your own risk!
'''
import gtk
import pygtk
import os.path
import os
import traceback
import sys
import webkit
import urlparse
import time
from gtkrg_profiles import fb_data1
from subprocess import *


class Publisher:
    def __init__(self, gallery, image_list, gtkrg_datadir):
        self.state = None
        self.gallery = gallery
        self.image_list = image_list
        self.formats = ('.png', '.jpg', '.jpeg')
        self.token = None
        self.stop = False
        self.uploading = False
        self.albums = {'default':'me'}
        self.tempfile = os.path.join(self.gallery.temp, 'tempfile.tiff')
        self.redirect_url = 'https://www.facebook.com/connect/login_success.html'
        self.logout_url = 'https://www.facebook.com/logout.php?next=%s&access_token=%s'
        self.scope = 'user_photos,publish_stream,offline_access'
        self.login_url = 'https://graph.facebook.com/oauth/authorize?client_id=%s&redirect_uri=%s&scope=%s&response_type=token' % (self._decode(fb_data1), self.redirect_url, self.scope)
        wtree = gtk.Builder()
        wtree.add_from_file(os.path.join(gtkrg_datadir, 'publisher.ui'))
        self.initialize_widgets(wtree)
        self.boxmodel1 = gtk.ListStore(str)
        cell = gtk.CellRendererText()
        self.combobox1.set_model(self.boxmodel1)
        self.combobox1.pack_start(cell, True)
        self.combobox1.add_attribute(cell, 'text', 0)
        self.boxmodel3 = gtk.ListStore(str)
        cell = gtk.CellRendererText()
        self.combobox3.set_model(self.boxmodel3)
        self.combobox3.pack_start(cell, True)
        self.combobox3.add_attribute(cell, 'text', 0)
        self.window1.set_icon_from_file(self.gallery.get_icon_path('facebook.png'))
        self.make_fb_treeview()
        if self.gallery.settings.has_key('token') and self.gallery.settings.has_key('fb_user') and self.gallery.settings['token'].get(self.gallery.settings['fb_user']):
            self.token = self._decode(self.gallery.settings['token'][self.gallery.settings['fb_user']])
        else:
            self.gallery.settings['token'] = {}
        self.checkbutton1.set_property('visible', False)
        self.checkbutton2.set_property('visible', False)
        self.boxmodel2 = gtk.ListStore(str)
        cell = gtk.CellRendererText()
        self.combobox2.set_model(self.boxmodel2)
        self.combobox2.pack_start(cell, True)
        self.combobox2.add_attribute(cell, 'text', 0)
        self.boxmodel2.append(['All Friends'])
        self.boxmodel2.append(['Friends of friends'])
        self.boxmodel2.append(['Everyone'])
        self.boxmodel2.append(['Self'])
        self.combobox2.set_active(0)
        # loads webview UI
        wview = gtk.Builder()
        wview.add_from_file(os.path.join(gtkrg_datadir, 'webview.ui'))
        self.browser = wview.get_object('window1')
        self.scrolled_window = wview.get_object('scrolledwindow1')
        self.wview_button = wview.get_object('button1')
        self.web_view = webkit.WebView()
        self.scrolled_window.add(self.web_view)
        self.browser.set_title(_('Log into Facebook'))
        self.browser.set_icon_from_file(self.gallery.get_icon_path('facebook.png'))
        self.browser.set_keep_above(True)
        self.connect_signals()
        if self.gallery.settings.has_key('token'):
            for key in sorted(self.gallery.settings['token'].keys()):
                self.boxmodel3.append([key])
            self.fb_user = self.gallery.settings.get('fb_user')
            self.combobox3.handler_block(self.id3)
            for row in self.boxmodel3:
                if row[0] == self.fb_user:
                    self.combobox3.set_active_iter(row.iter)
                    break
            else:
                self.combobox3.set_active(0)
            self.combobox3.handler_unblock(self.id3)
        if self.gallery.window3.get_property('visible'):
                self.window1.set_transient_for(self.gallery.window3)
        elif self.gallery.window2.get_property('visible'):
            self.window1.set_transient_for(self.gallery.window2)
        else:
            self.window1.set_transient_for(self.gallery.window1)

    def load_error(self, *obj):
        self.web_view.load_string(_('<div>Page Loading Error!</div>'), 'text/html', 'UTF-8', '#')

    def load_started(self, *obj):
        if self.browser.window:
            self.browser.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))

    def load_finished(self, *obj):
        if self.browser.window:
            self.browser.window.set_cursor(None)
        
    def hide_webview(self, obj, event=None):
        if obj == self.wview_button and self.wview_button.get_label() != 'gtk-ok':
            obj.set_label('gtk-ok')
            self.fb_login()
        else:
            self.browser.hide()
            return True

    def _load_committed_cb(self, web_view, frame):
        uri = frame.get_uri()
        parse = urlparse.urlparse(uri)
        if (hasattr(parse, 'netloc') and hasattr(parse, 'path') and hasattr(parse, 'fragment') and parse.netloc == 'www.facebook.com' and parse.path == '/connect/login_success.html'):
            if  parse.fragment:
                params = urlparse.parse_qs(parse.fragment)
                self.token = params['access_token'][0]
          #      token_expire = params['expires_in'][0]
                if self.token:
                    self.browser.hide()
                    self.refresh_facebook_albums()
            else:
                if self.state == 'logout':
                    self.token = False
                    self.fb_login()
                
    def on_renderer_toggled(self, cell, path, model, position):
        model[path][position] = not model[path][position]

    def make_fb_treeview(self):
        self.model = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)
        renderer_pix = gtk.CellRendererPixbuf()
        column_pix = gtk.TreeViewColumn("Preview", renderer_pix, pixbuf=0)
        column_pix.set_cell_data_func (renderer_pix, self.cell_data_function, None)
        self.treeview1.append_column(column_pix)
        cell = gtk.CellRendererText()                                                                           
        column_item = gtk.TreeViewColumn("Filename", cell, text=1)                    
        column_item.set_resizable(True)
        column_item.set_cell_data_func (cell, self.cell_data_function, None)
        self.treeview1.append_column(column_item)
        cell = gtk.CellRendererText()
        cell.set_property("editable", True)
        cell.connect("edited", self.on_model_edited, self.model, 2)
        column_item2 = gtk.TreeViewColumn("Caption", cell, text=2)
        column_item2.set_cell_data_func (cell, self.cell_data_function, None)
        column_item2.set_resizable(True)                                                                                         
        self.treeview1.append_column(column_item2)
        cell = gtk.CellRendererText()                                                                           
        column_item3 = gtk.TreeViewColumn("Status", cell, text=3)
        column_item3.set_cell_data_func (cell, self.cell_data_function, None)
        self.treeview1.append_column(column_item3)
        self.treeview1.set_model(self.model)

    def cell_data_function(self, column, cell, model, _iter, data=None):
        value = model.get_value(_iter, 3)
        if value == None:
            color = self.treeview1.rc_get_style().base[gtk.STATE_NORMAL].to_string()
        elif value == 'uploading...' or value == 'converting...':
            color = '#CD7300'
        elif value == 'error!':
            color = 'red'
        else:
            color = self.treeview1.rc_get_style().base[gtk.STATE_NORMAL].to_string()
        cell.set_property('cell_background', color)

    def on_model_edited(self, cell, path, new_text, model, column):
        if not new_text.isspace():
            model.set_value(model.get_iter(path), column, new_text)
        
    def initialize_widgets(self, tree):
        for widget in tree.get_objects():
            name = gtk.Buildable.get_name(widget)
            if name and not hasattr(self, name):
                setattr(self, name, widget)

    def connect_signals(self):
        self.button1.connect('clicked', self.destroy)
        self.button2.connect('clicked', self.upload)
        self.window1.connect('delete_event', self.destroy)
        self.window1.connect('key_press_event', self.on_key_press_event)
        self.radiobutton1.connect('toggled', self.on_radiobutton_toggled)
        self.button5.connect('clicked', self.new_login)
        self.id3 = self.combobox3.connect('changed', self.change_user_account)
        self.web_view.connect('load_committed', self._load_committed_cb) # Load page
        self.web_view.connect('load_error', self.load_error)
        self.web_view.connect('load_finished', self.load_finished)
        self.web_view.connect('load_started', self.load_started)
        self.wview_button.connect('clicked', self.hide_webview)
        self.browser.connect('delete_event', self.hide_webview)

    def on_radiobutton_toggled(self, obj):
        self.label4.set_sensitive(not obj.get_active())
        self.entry4.set_sensitive(not obj.get_active())
        self.entry1.set_sensitive(not obj.get_active())
        self.combobox1.set_sensitive(obj.get_active())
        self.combobox2.set_sensitive(not obj.get_active())
        self.label5.set_sensitive(not obj.get_active())

    def on_key_press_event(self, obj, event):
        keyname = gtk.gdk.keyval_name(event.keyval)
        if keyname == 'Delete' and len(self.model):
            selection = self.treeview1.get_selection()
            model, iter_ = selection.get_selected()
            if iter_:
                model.remove(iter_)

    def populate_album_box(self, albums, active_text=None):
        self.boxmodel1.clear()
        for album in sorted(albums):
            self.boxmodel1.append([album])
        if active_text:
            for row in self.boxmodel1:
                if row == active_text:
                    self.combobox1.set_active_iter(row.iter)
                    break
        else:            
            self.combobox1.set_active(0)

    def upload(self, obj):
        if len(self.model):
            self.button2.set_sensitive(False)
            self.stop = False
            self.uploading = True
            self.upload_to_facebook()
            self.stop = False
            self.uploading = False
            self.button2.set_sensitive(True)

    def upload_to_facebook(self):
        for row in self.model:
            self.model.set_value(row.iter, 3, None)
        self.progressbar1.set_fraction(0)
        self.progressbar1.show()
        fraction = 1.0 / len(self.model)
        if self.radiobutton1.get_active():
                album = self.combobox1.get_active_text() or 'default'
        else:
            album = self.entry1.get_text() or 'default'
            if album.isspace():
                album = 'default'
            description = self.entry4.get_text() or ''
            if album != 'default' and not album.isspace():
                for item in range(3):
                    album_id = self.create_album(album, description)
                    if album_id:
                        self.albums[album.decode('utf-8')] = album_id
                        self.populate_album_box(self.albums.keys(), self.combobox1.get_active_text())
                        break
                if not album_id:
                    album = 'default'   #we will try on default album
        for row in self.model:
            if self.stop:
                break
            photo = self.get_source(row[1], row.iter)
            caption = row[2] or ''
            if caption == '<edit>':
                caption = ''
            self.progressbar1.set_text(_('Uploading %s ...') % row[1])
            self.model.set_value(row.iter, 3, 'uploading...')
            while gtk.events_pending():
                gtk.main_iteration(False)
            for item in range(3):
                resp = self.upload_into_album(self.albums[album.decode('utf-8')], photo, caption)
                if resp:
                    break
            if resp:
                self.model.set_value(row.iter, 3, 'success!')
            else:
                self.model.set_value(row.iter, 3, 'error!')
            self.progressbar1.set_fraction(self.progressbar1.get_fraction() + fraction)
            self.treeview1.scroll_to_cell(self.model.get_path(row.iter))
            while gtk.events_pending():
                gtk.main_iteration(False)
        time.sleep(1)
        self.progressbar1.hide()
        if os.path.isfile(self.tempfile):
            os.remove(self.tempfile)

    def create_album(self, album_name, description):
        active = self.combobox2.get_active()
        d ={0:'ALL_FRIENDS',1:'FRIENDS_OF_FRIENDS',2:'EVERYONE',3:'SELF'}
        import json
        resp = self.graph.put_album('me', name=album_name, message=description, privacy=json.dumps({"value":d[active]}))
        print resp
        if resp:
            return resp.get('id')
        return None

    def upload_into_album(self, album_id, photo, caption):
        source = open(photo, 'rb')
        resp = self.graph.put_photo(album_id, message=caption, source=source)   #source is a file like object
        source.close()
        print resp
        return resp
        
    def scale_image(self, photo):
        if isinstance(photo, str):
            pixbuf = gtk.gdk.pixbuf_new_from_file(photo)
        else:
            pixbuf = photo
        width, height = pixbuf.get_width(), pixbuf.get_height()
        if width > 720 or height > 720: #facebook display size
            ratio = float(width) / height
            if ratio >= 1:
                pixbuf = pixbuf.scale_simple(720, int(height * float(720) / width), gtk.gdk.INTERP_BILINEAR)
            else:
                pixbuf = pixbuf.scale_simple(int(width * float(720) / height) , 720, gtk.gdk.INTERP_BILINEAR)
            filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
            pixbuf.save(filename, "jpeg", {"quality":"100"})
            photo = filename
        return photo

    def process_raw(self, filename):
        format_ = os.path.splitext(filename)[1]
        fname = os.path.basename(filename)[:-len(format_)]
        outfile = self.tempfile
        options = self.gallery.dcraw_options2()       #we get current dcraw settings from dcraw gui panel
        if '-h' not in options:                                     #with -h option for quick extraction.
            options.insert(1, '-h')
        command = ' '.join(options)
        p = Popen(command % (filename, outfile), shell=True, stdin=PIPE, stdout=PIPE, stderr=STDOUT, universal_newlines=True, env={'LANG':'en_Us'}, creationflags = self.gallery.CREATIONFLAGS)
        output = p.communicate()[0]
        p.stdout.close()
        p.stdin.close()
        return outfile

    def get_source(self, name_, iter_):
        name = self.rawpath[name_]
        if self.gallery.window2.get_property('visible'):
            pixbuf = self.gallery.get_print_pixbuf(True)
            if self.checkbutton3.get_active():
                photo = self.scale_image(pixbuf)
            else:
                filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
                pixbuf.save(filename, "jpeg", {"quality":"100"})
                photo = filename
        else:
            if name.lower().endswith(self.formats):
                photo = name
                if self.checkbutton3.get_active():
                    photo = self.scale_image(photo)
            elif name.lower().endswith(self.gallery.raw_formats):# raw images
                self.model.set_value(iter_, 3, 'converting...')
                while gtk.events_pending():
                    gtk.main_iteration(False)
                photo = self.process_raw(self.gallery.get_real_path(name))
                if self.checkbutton3.get_active():
                    photo = self.scale_image(photo)
                if photo.lower().endswith('.tiff'):
                    pixbuf = gtk.gdk.pixbuf_new_from_file(photo)
                    filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
                    pixbuf.save(filename, "jpeg", {"quality":"100"})
                    photo = filename
            else:
                pixbuf = gtk.gdk.pixbuf_new_from_file(name)
                if self.checkbutton3.get_active():
                    width, height = pixbuf.get_width(), pixbuf.get_height()
                    if width > 720 or height > 720:
                        ratio = float(width) / height
                        if ratio >= 1:
                            pixbuf = pixbuf.scale_simple(720, int(height * float(720 / width)), gtk.gdk.INTERP_BILINEAR)
                        else:
                            pixbuf = pixbuf.scale_simple(int(width * float(720 / height)) , 720, gtk.gdk.INTERP_BILINEAR)
                filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
                pixbuf.save(filename, "jpeg", {"quality":"100"})
                photo = filename
        return photo
                               
    def refresh_treeview(self):
        self.rawpath = {}
        self.model.clear()
        for item in self.gallery.selected:
            basename = os.path.basename(self.gallery.get_real_path(item))
            self.rawpath[basename] = item
            if self.image_list[0] == self.gallery.image28:
                pixbuf = self.gallery.scale_thumbnail(self.image_list[0].get_pixbuf().copy())
            else:
                pixbuf = self.gallery.scale_thumbnail(self.image_list[self.gallery.list.index(item)].get_pixbuf().copy())
            self.model.append([pixbuf, basename, '<edit>', None])
            while gtk.events_pending():
                gtk.main_iteration(False)

    def new_login(self, obj):
        self.window1.iconify()
        while gtk.events_pending():
            gtk.main_iteration(False)
        self.wview_button.set_label(_('Continue'))
        if self.token:
            self.state = 'logout'
            self.stop = True
            self.fb_logout()
        else:
            self.fb_login()

    def change_user_account(self, obj, event=None):
        username = obj.get_active_text()
        if username:
            self.token = self._decode(self.gallery.settings['token'][username])
            self.refresh_facebook_albums(username)
        
    def refresh_facebook_albums(self, username=None):
        self.window1.present()
        self.window1.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))
        if self.token:
            self.label3.set_text(_('Retrieving albums...'))
            while gtk.events_pending():
                gtk.main_iteration(False)
            import facebook
            self.profile = None
            try:
                self.graph = facebook.GraphAPI(self.token)
                self.profile = self.graph.get_object('me')
            except:
                sys.stderr.write(traceback.format_exc())
                self.token = None
                self.label3.set_text(_('Token expired!'))
                while gtk.events_pending():
                    gtk.main_iteration(False)
                if username and self.gallery.settings['token'].has_key(username):
                    del self.gallery.settings['token'][username]
                    for row in self.boxmodel3:
                        if row[0] == username:
                            self.boxmodel3.remove(row.iter)
            if self.profile:
                self.window1.set_title(_('Publish on %s Facebook account') % self.profile['name'])
                while gtk.events_pending():
                    gtk.main_iteration(False)
                albums = self.graph.get_connections('me', 'albums')
                self.gallery.settings['fb_user'] = self.profile['username']
                self.gallery.settings['token'][self.gallery.settings['fb_user']] = self._encode(self.token)
                self.combobox3.handler_block(self.id3)
                self.boxmodel3.clear()
                for key in self.gallery.settings['token'].keys():
                    self.boxmodel3.append([key])
                for row in self.boxmodel3:
                    if row[0] == self.profile['username']:
                        self.combobox3.set_active_iter(row.iter)
                        break
                else:
                    self.combobox3.set_active(0)
                self.combobox3.handler_unblock(self.id3)   
                album_list = []
                if albums:
                    for item in albums['data']:
                        album_list.append(item['name'])
                        self.albums[item['name']] = item['id']
                    self.populate_album_box(album_list)
                self.button2.set_sensitive(True)
                self.label3.set_text(_('you have %s albums') % len(album_list))
                self.window1.window.set_cursor(None)
                while gtk.events_pending():
                    gtk.main_iteration(False)
                self.window1.window.set_cursor(None)
                return True
        self.window1.window.set_cursor(None)
        return False

    def fb_logout(self):
        self.web_view.load_uri(self.logout_url % (self.redirect_url, self.token))

    def fb_login(self, login=None):
        if not self.browser.get_property('visible'):
            self.browser.show_all()
        if self.wview_button.get_label() != 'gtk-ok':
            self.web_view.load_string(_('<div>Log into your Facebook to authorize GTKRawGallery and click OK.<p>Click Continue.</p></div>'), 'text/html', 'UTF-8', '#')
            while gtk.events_pending():
                gtk.main_iteration(False)
        else:
            self.state = 'login'
            self.web_view.load_uri(self.login_url)

    def _decode(self, data):
        return ''.join([chr(i) for i in data])

    def _encode(self, data):
        return [ord(i) for i in data]
 
    def main(self):
        self.gallery.window2.set_modal(False)
        self.window1.set_title(_('Publish on Facebook'))
        self.progressbar1.hide()
        self.refresh_treeview()
        if not self.token:
            self.wview_button.set_label(_('Continue'))
            self.fb_login()
        else:
            self.refresh_facebook_albums(self.fb_user)

    def destroy(self, *obj):
        self.gallery.window2.set_modal(True)
        if self.uploading:
            self.stop = True
        self.window1.hide_all()
        self.gallery.unselect()
        while gtk.events_pending():
            gtk.main_iteration(False)
        self.model.clear()
        self.browser.destroy()
        self.window1.destroy()

        
