# -*- coding: cp1252 -*-
'''
GTKRawGallery Picasa Web Albums Publisher;
copyright  2013 Daniele Isca
license: GNU GPL v.3 (see COPYING.txt);
This software comes with no warranty of any kind, use at your own risk!
'''
import gtk
import pygtk
import os.path
import os
import sys
import traceback
import time
import mimetypes
import gdata.photos
from gdata import service
from subprocess import *


class Publisher:
    def __init__(self, gallery, image_list, gtkrg_datadir):
        self.client = None
        self.stop = False
        self.uploading = False
        self.formats = ('.jpeg', '.jpg', '.png', '.gif', '.bmp')
        self.gallery = gallery
        self.tempfile = os.path.join(self.gallery.temp, 'tempfile.tiff')
        self.image_list = image_list
        wtree = gtk.Builder()
        wtree.add_from_file(os.path.join(gtkrg_datadir, 'publisher.ui'))
        self.initialize_widgets(wtree)
        self.boxmodel1 = gtk.ListStore(str)
        cell = gtk.CellRendererText()
        self.combobox1.set_model(self.boxmodel1)
        self.combobox1.pack_start(cell, True)
        self.combobox1.add_attribute(cell, 'text', 0)
        self.boxmodel3 = gtk.ListStore(str)
        cell = gtk.CellRendererText()
        self.combobox3.set_model(self.boxmodel3)
        self.combobox3.pack_start(cell, True)
        self.combobox3.add_attribute(cell, 'text', 0)
        self.window1.set_icon_from_file(self.gallery.get_icon_path('picasa.png'))
        self.dialog1.set_icon_from_file(self.gallery.get_icon_path('picasa.png'))
        self.make_pwa_treeview()
        self.entry3.set_activates_default(True)
        self.dialog1.set_default_response(-5)
        self.window1.set_title(_('Publish on Picasa Web Albums'))
        self.dialog1.set_title(_('Log into Picasa Web Albums'))
        self.user = ''
        self.pwd = ''
        if self.gallery.settings.has_key('pwa_user'):
            self.user = self.gallery.settings['pwa_user']
        self.entry2.set_text(self.user)
        if self.gallery.settings.has_key('pwa_pass'):
            self.pwd = self.gallery.settings['pwa_pass'].get(self.user)
        else:
            self.gallery.settings['pwa_pass'] = {}
        self.entry3.set_text(self.pwd)
        self.connect_signals()
        self.combobox2.set_property('visible', False)
        self.label5.set_property('visible', False)
        self.label6.set_text('Username:')
        if self.gallery.settings.has_key('pwa_pass'):
            self.combobox3.handler_block(self.id3)
            for key in sorted(self.gallery.settings['pwa_pass'].keys()):
                self.boxmodel3.append([key])
            for row in self.boxmodel3:
                if row[0] == self.user:
                    self.combobox3.set_active_iter(row.iter)
                    break
            else:
                self.combobox3.set_active(0)
            self.combobox3.handler_unblock(self.id3)
        if self.gallery.window3.get_property('visible'):
            self.window1.set_transient_for(self.gallery.window3)
        elif self.gallery.window2.get_property('visible'):
            self.window1.set_transient_for(self.gallery.window2)
        else:
            self.window1.set_transient_for(self.gallery.window1)

    def on_renderer_toggled(self, cell, path, model, position):
        model[path][position] = not model[path][position]

    def make_pwa_treeview(self):
        self.model = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str, str, str)
        renderer_pix = gtk.CellRendererPixbuf()
        column_pix = gtk.TreeViewColumn("Preview", renderer_pix, pixbuf=0)
        column_pix.set_cell_data_func (renderer_pix, self.cell_data_function, None)
        self.treeview1.append_column(column_pix)
        cell = gtk.CellRendererText()                                                                           
        column_item = gtk.TreeViewColumn("Filename", cell, text=1)
        column_item.set_cell_data_func (cell, self.cell_data_function, None)
        column_item.set_resizable(True)                                                                                         
        self.treeview1.append_column(column_item)
        cell = gtk.CellRendererText()
        cell.set_property("editable", True)
        cell.connect("edited", self.on_model_edited, self.model, 2)
        column_item2 = gtk.TreeViewColumn("Title", cell, text=2)
        column_item2.set_cell_data_func (cell, self.cell_data_function, None)
        column_item2.set_resizable(True)                                                                                         
        self.treeview1.append_column(column_item2)
        cell = gtk.CellRendererText()
        cell.set_property("editable", True)
        cell.connect("edited", self.on_model_edited, self.model, 3)
        column_item3 = gtk.TreeViewColumn("Caption", cell, text=3)
        column_item3.set_cell_data_func (cell, self.cell_data_function, None)
        column_item3.set_resizable(True)                                                                                         
        self.treeview1.append_column(column_item3)
        cell = gtk.CellRendererText()
        cell.set_property("editable", True)
        cell.connect("edited", self.on_model_edited, self.model, 4)
        column_item4 = gtk.TreeViewColumn("Tags", cell, text=4)
        column_item4.set_cell_data_func (cell, self.cell_data_function, None)
        column_item4.set_resizable(True)                                                                                         
        self.treeview1.append_column(column_item4)
        cell = gtk.CellRendererText()                                                                           
        column_item5 = gtk.TreeViewColumn("Status", cell, text=5)
        column_item5.set_cell_data_func (cell, self.cell_data_function, None)
        self.treeview1.append_column(column_item5)
        self.treeview1.set_model(self.model)

    def cell_data_function(self, column, cell, model, _iter, data=None):
        value = model.get_value(_iter, 5)
        if value == None:
            color = self.treeview1.rc_get_style().base[gtk.STATE_NORMAL].to_string()
        elif value == 'uploading...' or value == 'converting...':
            color = '#CD7300'
        elif value == 'error!':
            color = 'red'
        else:
            color = self.treeview1.rc_get_style().base[gtk.STATE_NORMAL].to_string()
        cell.set_property('cell_background', color)

    def on_model_edited(self, cell, path, new_text, model, column):
        if not new_text.isspace():
            model.set_value(model.get_iter(path), column, new_text)
        
    def initialize_widgets(self, tree):
        for widget in tree.get_objects():
            name = gtk.Buildable.get_name(widget)
            if name and not hasattr(self, name):
                setattr(self, name, widget)

    def connect_signals(self):
        self.button1.connect('clicked', self.destroy)
        self.button2.connect('clicked', self.upload)
        self.window1.connect('delete_event', self.destroy)
        self.window1.connect('key_press_event', self.on_key_press_event)
        self.radiobutton1.connect('toggled', self.on_radiobutton_toggled)
        self.button5.connect('clicked', self.change_user_account)
        self.id3 = self.combobox3.connect('changed', self.change_user_account)

    def on_radiobutton_toggled(self, obj):
        self.label4.set_sensitive(not obj.get_active())
        self.entry4.set_sensitive(not obj.get_active())
        self.entry1.set_sensitive(not obj.get_active())
        self.combobox1.set_sensitive(obj.get_active())

    def on_key_press_event(self, obj, event):
        keyname = gtk.gdk.keyval_name(event.keyval)
        if keyname == 'Delete' and len(self.model):
            selection = self.treeview1.get_selection()
            model, iter_ = selection.get_selected()
            if iter_:
                model.remove(iter_)

    def populate_album_box(self, albums):
        self.boxmodel1.clear()
        for album in sorted(albums):
            self.boxmodel1.append([album])
        self.combobox1.set_active(0)

    def scale_image(self, photo):
        if isinstance(photo, str):
            pixbuf = gtk.gdk.pixbuf_new_from_file(photo)
        else:
            pixbuf = photo
        width, height = pixbuf.get_width(), pixbuf.get_height()
        if width > 720 or height > 720:
            ratio = float(width) / height
            if ratio >= 1:
                pixbuf = pixbuf.scale_simple(720, int(height * float(720) / width), gtk.gdk.INTERP_BILINEAR)
            else:
                pixbuf = pixbuf.scale_simple(int(width * float(720) / height), 720, gtk.gdk.INTERP_BILINEAR)
            filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
            pixbuf.save(filename, "jpeg", {"quality":"100"})
            photo = filename
        return photo

    def process_raw(self, filename):
        format_ = os.path.splitext(filename)[1]
        fname = os.path.basename(filename)[:-len(format_)]
        outfile = self.tempfile
        options = self.gallery.dcraw_options2()
        if '-h' not in options:
            options.insert(1, '-h')
        command = ' '.join(options)
        p = Popen(command % (filename, outfile), shell=True, stdin=PIPE, stdout=PIPE, stderr=STDOUT, universal_newlines=True, env={'LANG':'en_Us'}, creationflags = self.gallery.CREATIONFLAGS)
        output = p.communicate()[0]
        p.stdout.close()
        p.stdin.close()
        return outfile

    def get_source(self, basename, iter_):
        name = self.rawpath[basename]
        if self.gallery.window2.get_property('visible'):
            pixbuf = self.gallery.get_print_pixbuf(True)
            if self.checkbutton3.get_active():
                photo = self.scale_image(pixbuf)
            else:
                filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
                pixbuf.save(filename, "jpeg", {"quality":"100"})
                photo = filename
        else:
            if name.lower().endswith(self.formats):
                photo = name
                if self.checkbutton3.get_active():
                    photo = self.scale_image(photo)
            elif name.lower().endswith(self.gallery.raw_formats):   # raw images
                self.model.set_value(iter_, 5, 'converting...')
                while gtk.events_pending():
                    gtk.main_iteration(False)
                photo = self.process_raw(self.gallery.get_real_path(name))
                if self.checkbutton3.get_active():
                    photo = self.scale_image(photo)
                if photo.lower().endswith('.tiff'):
                    pixbuf = gtk.gdk.pixbuf_new_from_file(photo)
                    filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
                    pixbuf.save(filename, "jpeg", {"quality":"100"})
                    photo = filename
            else:
                pixbuf = gtk.gdk.pixbuf_new_from_file(name)
                if self.checkbutton3.get_active():
                    width, height = pixbuf.get_width(), pixbuf.get_height()
                    if width > 720 or height > 720:
                        ratio = float(width) / height
                        if ratio >= 1:
                            pixbuf = pixbuf.scale_simple(720, int(height * float(720 / width)), gtk.gdk.INTERP_BILINEAR)
                        else:
                            pixbuf = pixbuf.scale_simple(int(width * float(720 / height)), 720, gtk.gdk.INTERP_BILINEAR)
                filename = os.path.join(self.gallery.temp, 'mytemp.jpeg')
                pixbuf.save(filename, "jpeg", {"quality":"100"})
                photo = filename
        return photo

    def upload(self, obj):
        if len(self.model):
            self.button2.set_sensitive(False)
            self.stop = False
            self.uploading = True
            self.upload_to_pwa()
            self.stop = False
            self.uploading = False
            self.button2.set_sensitive(True)
            
    def upload_to_pwa(self, obj=None):
        for row in self.model:
            self.model.set_value(row.iter, 5, None)
        self.progressbar1.set_fraction(0)
        self.progressbar1.show()
        fraction = 0.99 / len(self.model)
        if self.radiobutton1.get_active():
                album = self.combobox1.get_active_text() or 'default'
        else:
            album = self.entry1.get_text() or 'default'
            if album.isspace():
                album = 'default'
            description = self.entry4.get_text() or ' '
            if album != 'default' and not album.isspace():
                resp = self.create_album(album, description)
                if resp:
                    self.refresh_pwa_albums()
        for row in self.model:
            if self.stop:
                break
            photo = self.get_source(row[1], row.iter)
            title = row[2] or row[1]
            if title == '<edit>':
                title = row[1]
            caption = row[3] or None
            if caption == '<edit>':
                caption = None
            tags = row[4] or None
            if tags == '<edit>':
                tags = None
            self.progressbar1.set_text(_('Uploading %s ...') % row[1])
            self.model.set_value(row.iter, 5, 'uploading...')
            while gtk.events_pending():
                gtk.main_iteration(False)
            for item in range(3):
                resp = self.upload_into_album(album, photo, title, caption, tags)
                if resp:
                    break
            if resp:
                self.model.set_value(row.iter, 5, 'success!')
            else:
                self.model.set_value(row.iter, 5, 'error!')
            self.progressbar1.set_fraction(self.progressbar1.get_fraction() + fraction)
            self.treeview1.scroll_to_cell(self.model.get_path(row.iter))
            while gtk.events_pending():
                gtk.main_iteration(False)
        time.sleep(1)
        self.progressbar1.hide()
        if os.path.isfile(self.tempfile):
            os.remove(self.tempfile)

    def upload_into_album(self, album_name, photo, title, caption, tags):
        if album_name == 'default':
            url = '/data/feed/api/user/default/albumid/default'
        else:
            for album in self.client.GetUserFeed().entry:
                if album.title.text == album_name:
                    url = '/data/feed/api/user/default/albumid/%s' % album.gphoto_id.text
                    break
            else:
                url = '/data/feed/api/user/default/albumid/%s' % album_name
        resp = self.client.InsertPhotoSimple(url, title, caption, photo, mimetypes.guess_type(photo)[0], tags)
        return isinstance(resp, gdata.photos.PhotoEntry)

    def create_album(self, album, description):
        if self.checkbutton1.get_active():
            access = 'public'
        else:
            access = 'private'
        if self.checkbutton2.get_active():
            commenting = 'true'
        else:
            commenting = 'false'
        resp = self.client.InsertAlbum(title=album, summary=description, access=access, commenting_enabled=commenting)
        return isinstance(resp, gdata.photos.AlbumEntry)
                               
    def refresh_treeview(self):
        self.rawpath = {}
        self.model.clear()
        for item in self.gallery.selected:
            source = os.path.basename(self.gallery.get_real_path(item))
            self.rawpath[source] = item
            if self.image_list[0] == self.gallery.image28:
                pixbuf = self.gallery.scale_thumbnail(self.image_list[0].get_pixbuf().copy())
            else:
                pixbuf = self.gallery.scale_thumbnail(self.image_list[self.gallery.list.index(item)].get_pixbuf().copy())
            self.model.append([pixbuf, source, '<edit>', '<edit>', '<edit>', None])
            while gtk.events_pending():
                gtk.main_iteration(False)
        
    def refresh_pwa_albums(self, obj=None):
        if self.pwa_login():
            self.label3.set_text(_('Retrieving albums...'))
            while gtk.events_pending():
                gtk.main_iteration(False)
            album_list = []
            albums = self.client.GetUserFeed()
            for album in albums.entry:
                album_list.append(album.title.text)
            if album_list:
                self.populate_album_box(album_list)
            self.button2.set_sensitive(True)
            self.label3.set_text(_('you have %s albums') % len(album_list))
            self.window1.window.set_cursor(None)
            while gtk.events_pending():
                gtk.main_iteration(False)
            self.window1.window.set_cursor(None)
            return True
        self.window1.window.set_cursor(None)
        return False

    def change_user_account(self, obj):
        if obj == self.button5:
            self.user = ''
            self.pwd = ''
        else:
            self.user = obj.get_active_text()
            self.pwd = self.gallery.settings['pwa_pass'].get(self.user)
        if not self.refresh_pwa_albums():
            self.destroy(None)

    def pwa_login(self):
        if self.user and self.pwd:
            credentials = (self.user, self.pwd)
        else:
            credentials = self.dialog()
        if credentials:
            self.window1.present()
            self.progressbar1.hide()
            self.window1.window.set_cursor(self.gallery.watch)
            self.label3.set_text(_('Authenticating...'))
            while gtk.events_pending():
                gtk.main_iteration(False)
            import gdata.photos.service
            try:
                self.client = gdata.photos.service.PhotosService()
                self.client.email = credentials[0]
                self.client.password = credentials[1]
                self.client.source = 'GTKRawGallery'
                self.client.ProgrammaticLogin()
                self.gallery.settings['pwa_user'] = self.user = self.entry2.get_text()
                self.gallery.settings['pwa_pass'][self.user] = self.pwd = self.entry3.get_text()
                if self.gallery.settings.has_key('pwa_pass'):
                    self.combobox3.handler_block(self.id3)
                    for key in sorted(self.gallery.settings['pwa_pass'].keys()):
                        self.boxmodel3.append([key])
                    for row in self.boxmodel3:
                        if row[0] == self.user:
                            self.combobox3.set_active_iter(row.iter)
                            break
                    else:
                        self.combobox3.set_active(0)
                return True
            except service.BadAuthentication:
                gtk.gdk.beep()
                self.pwd = ''
                self.label3.set_text(_('Invalid username or password!'))
                self.window1.window.set_cursor(None)
                self.pwa_login()
            except:
                gtk.gdk.beep()
                self.pwd = ''
                self.label3.set_text(_('Log-in failed!'))
                sys.stderr.write(traceback.format_exc())
                self.window1.window.set_cursor(None)
                self.pwa_login()
        return None
                           
    def dialog(self):
        self.dialog1.show()
        if self.entry2.get_text():
            self.entry3.grab_focus()
        while gtk.events_pending():
            gtk.main_iteration(False)
        res = self.dialog1.run()
        if res in [-4, -6]:
            self.dialog1.hide()
            return None
        else:
            user = self.entry2.get_text()
            if not user:
                self.dialog()
            pwd = self.entry3.get_text()
            if not pwd:
                self.dialog()
            self.dialog1.hide()
            while gtk.events_pending():
                gtk.main_iteration(False)
            return user, pwd
 
    def main(self):
        self.gallery.window2.set_modal(False)
        self.refresh_treeview()
        if not self.refresh_pwa_albums():
            self.destroy(None)

    def destroy(self, *obj):
        self.gallery.window2.set_modal(True)
        if self.uploading:
            self.stop = True
        self.window1.hide_all()
        self.gallery.unselect()
        while gtk.events_pending():
            gtk.main_iteration(False)
        if self.client:
            del self.client
        self.model.clear()
        self.window1.destroy()
        return True


