#!/usr/bin/env python
# -*- coding: utf-8 -*-
'''
description: GTKRawGallery uninstaller for Linux
copyright © 2013 Daniele Isca
license: GNU GPL v.3 (see COPYING.txt);
This software comes with no warranty of any kind, use at your own risk!
'''
import os.path
import os
import sys
import shutil
from distutils.sysconfig import get_python_lib

print """
        =============================
        * GTKRawGallery uninstaller *
        =============================
"""

if os.path.exists('/usr/local/share/gtkrawgallery'):
	prefix = '/usr/local'
elif os.path.exists('/usr/share/gtkrawgallery'):
	prefix = '/usr'
else:
	prefix = sys.prefix
	
path_ = os.path.join(prefix, 'share', 'gtkrawgallery')	
if os.path.exists(path_):
	shutil.rmtree(path_, ignore_errors=True)
	print '\nremoving folder %s ......done!' % path_
else:
    	print '\nfolder %s not found' % path_

pathlist = [os.path.join(prefix, 'share', 'pixmaps', 'gtkrawgallery.png'),
            os.path.join(prefix, 'share', 'applications', 'gtkrawgallery.desktop'),
            os.path.join(prefix, 'bin', 'gtkrawgallery'),
            os.path.join(get_python_lib(), 'gtkrawgallery.py'),
            os.path.join(get_python_lib(), 'gtkrawgallery.pyc'),
            os.path.join(get_python_lib(), 'uninstall-gtkrawgallery.py'),
            os.path.join(get_python_lib(), 'uninstall-gtkrawgallery.pyc'),
            os.path.join(get_python_lib(), 'uninstall_gtkrawgallery.py'),
            os.path.join(get_python_lib(), 'uninstall_gtkrawgallery.pyc'),
            os.path.join(prefix, 'bin', 'uninstall-gtkrawgallery')]

for path_ in pathlist:
        if os.path.isfile(path_):
                os.remove(path_)
                print 'removing %s ......done!' % path_
        else:
                print 'file %s not found' % path_
                
print '\nThe folder .GTKRawGallery in your HOME directory has to be removed manually!'
print '\nDo not remove if you are going to update GTKRawGallery to not lose albums and tags.'
print '\nUninstall completed!\n'

